// Code C qui sert d'illustration au cours cm1-processus de l'UE LIF12.
// les indications de correspondance avec les slides du cours, qui figurent dans le code,
// correspondent à la version du 13/02/2009
#include <sys/wait.h>
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <ucontext.h>

// #######################################################
// Fonction pour gérer les signaux - slide 42 à 45 + TD1
// #######################################################
void     ma_fonction (int num_signal, siginfo_t *info_signal,void *cont){
  fprintf(stderr, "Le père me prévient d'un problème\n");
}


int
main(int argc, char *argv[])
{
  int pipefd[2];
  pid_t code;
  char buf;
  int res;
  struct sigaction action, ancienne_action;

  // #########################################################
  // On test s'il y a un argument sur la ligne de commande pour avoir un message à échanger
  // #########################################################
  //assert(argc == 2);
  if (argc != 2) {
    fprintf(stderr, "Usage %s \"un_truc\" pour faire passer le message un truc\n   ou %s erreur pour simuler une erreur de calcul\n", argv[0], argv[0]);
    exit(2);
  }

  // #########################################################
  // Création du pipe - slide 30 à 35
  // #########################################################
  if (pipe(pipefd) == -1) {
    fprintf(stderr, "erreur du pipe : %s", strerror(errno));
    exit(EXIT_FAILURE);
  }

  // #########################################################
  // Duplication du processus slide 13 à 16
  // #########################################################
  code = fork();
  if (code == -1) {
    perror("fork");
    exit(EXIT_FAILURE);
  }

  
  if (code == 0) {
    // #########################################################
    // #########################################################
    // Code du fils 
    // #########################################################
    // #########################################################
  
    close(pipefd[1]);  /* Ferme l’extrémité d’écriture inutilisée - slide 32-34 */
    
    //    sleep(2);
    fprintf(stdout, "Le fils : j'attend\n");

    // #########################################################
    // Gestion simple d'un signal pour le fils
    // Récupération du signal SIGUSR1 si le père a un problème
    // - slide 42 à 45 + TD1
    // #########################################################
    res = sigaction(SIGUSR1, NULL, &action); // On récupère l'ancienne action pour initialiser
    // on modifie l'action
    action.sa_sigaction =  ma_fonction; // La fonction à appeler
    action.sa_flags = SA_SIGINFO; // Pour dire d'utiliser un sa_sigaction à la place du sa_handler moin précis
    // on met en place la nouvelle gestion de signal
    res = sigaction(SIGUSR1, &action, &ancienne_action);
    if (res == -1) {
      perror("problème avec le gestionaire de signaux ");
      exit(1);
    }
    
    // #########################################################
    // Le fils attend le père et lit le résultat - slide 36 à 40
    // #########################################################
    while ((res = read(pipefd[0], &buf, 1)) != 0) {
      if (res < 0) {
	 fprintf(stderr, "Le fils : erreur pour la lecture : %s\n", strerror(errno));
	 exit(14);
      }
      fprintf(stdout, "Le fils : je lit %c\n", buf);
    }

    // On remet en place l'ancien gestionaire de signaux
    res = sigaction(SIGUSR1, &ancienne_action, NULL);
    if (res == -1) {
      perror("problème avec le gestionaire de signaux ");
      exit(1);
    }

    // #########################################################
    // Calcul du fils
    // #########################################################
    fprintf(stdout, "Le fils : je calcule\n");
    sleep(1); // simulation du calcul par un sleep


    // #########################################################
    // terminaison du fils - slide 17 à 21
    // #########################################################
    fprintf(stdout, "Le fils : j'ai fini\n");
    close(pipefd[0]);
    _exit(23);

  } else {
    // #########################################################
    // #########################################################
    // Code du père
    // #########################################################
    // #########################################################
    int status;
    close(pipefd[0]);       /* Ferme l’extrémité de lecture inutilisée - slide 32-34 */
    
    // #########################################################
    // Calcul du père
    // #########################################################
    fprintf(stdout, "Le pere : je calcule\n");
    sleep(1); // simulation du calcul par un sleep

    
    // #########################################################
    // Simulation d'une erreur dans le calcul (qui demande de prévenir le fils)
    // - slide 42 à 45 + TD1
    // #########################################################
    if (strcmp(argv[1], "erreur")==0) {
      // Le mot erreur a été passé en argument je souhaite donc simuler un problème de calcul
      fprintf(stdout, "Le pere : j'ai un souci, je préviens le fils\n");
      kill(code, SIGUSR1); // pour prévenir le fils
      sleep(1); // Pour passer la main au fils.
    } else {

      // #########################################################
      // Le père envoie un méssage au fils - slide 36 à 40
      // #########################################################
      fprintf(stdout, "Le pere : j'envoie au fils\n");
      res = write(pipefd[1], argv[1], strlen(argv[1])); // envoie de argv[1], le 2ème mot sur la ligne de comande
      if (res == -1) {
	fprintf(stderr, "Le pere : erreur pour l'écriture : %s\n", strerror(errno));
	exit(1);
      }
    }

    // #########################################################
    // Le père a fini 
    // #########################################################
    fprintf(stdout, "Le pere : envoie fini\n");
    close(pipefd[1]);       /* Le lecteur verra EOF => le read aura 0 comme résultat*/

    // #########################################################
    // Enterrement du fils - slide 17 à 21
    // #########################################################
    fprintf(stdout, "Le pere : j'attend la fin du fils\n");
    waitpid(-1,&status, 0);             /* Attente du fils */
    if (WIFEXITED(status)) {
      fprintf(stdout, "Le Père : le fils s'est terminé normalement et a renvoyé %d\n", WEXITSTATUS(status));
    } else {
      fprintf(stdout, "Le Père : le fils ne s'est pas terminé normalement\n");
    }

    // #########################################################
    // Fin du père
    // #########################################################
    fprintf(stdout, "Le pere : j'ai fini\n");
    exit(EXIT_SUCCESS);
  }
}
